// ErrorMsg.h
//
// M. Woodring
// http://www.bearcanyon.com
//
#include <windows.h>

inline void ErrorMessage( LPCTSTR szFn, DWORD dwError = GetLastError() )
{
    TCHAR   szTitle[1024];
    TCHAR   szPrompt[1024];
    BOOL    bRet;
    
    bRet = FormatMessage( FORMAT_MESSAGE_FROM_SYSTEM, 0, dwError,
                          0, szPrompt, sizeof(szPrompt), 0 );

    if( !bRet )
    {
        lstrcpy(szPrompt, __TEXT("Unknown Error"));
    }

    wsprintf( szTitle, __TEXT("%s failed with error code (0x%x)!"),
              szFn, dwError );

    int idChoice;
    
    idChoice = MessageBox( HWND_DESKTOP, szPrompt, szTitle,
                           MB_ABORTRETRYIGNORE | MB_SETFOREGROUND );

    if( idChoice != IDIGNORE )
    {
        ExitProcess(0);
    }
}

class Win32Error
{
public:
    Win32Error( DWORD dwError = GetLastError() )
        : m_pszError(0)
    {
        BOOL    bRet;
    
        bRet =
            FormatMessage( FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_ALLOCATE_BUFFER,
                           0, dwError, 0, (LPTSTR)&m_pszError, 64, 0 );

        if( !bRet )
        {
            wsprintf(m_pszError, __TEXT("Unrecognized"));
        }
    }

    operator TCHAR *()
    {
        return(m_pszError);
    }

    ~Win32Error()
    {
        if( m_pszError )
        {
            LocalFree((HLOCAL)m_pszError);
        }
    }

private:
    TCHAR  *m_pszError;
};

